/**
  Generated Main Source File

  Company:
    Microchip Technology Inc.

  File Name:
    main.c

  Summary:
    This is the main file generated using PIC10 / PIC12 / PIC16 / PIC18 MCUs

  Description:
    This header file provides implementations for driver APIs for all modules selected in the GUI.
    Generation Information :
        Product Revision  :  PIC10 / PIC12 / PIC16 / PIC18 MCUs - 1.77
        Device            :  PIC12F1822
        Driver Version    :  2.00
*/

/*
    (c) 2018 Microchip Technology Inc. and its subsidiaries. 
    
    Subject to your compliance with these terms, you may use Microchip software and any 
    derivatives exclusively with Microchip products. It is your responsibility to comply with third party 
    license terms applicable to your use of third party software (including open source software) that 
    may accompany Microchip software.
    
    THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES, WHETHER 
    EXPRESS, IMPLIED OR STATUTORY, APPLY TO THIS SOFTWARE, INCLUDING ANY 
    IMPLIED WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS 
    FOR A PARTICULAR PURPOSE.
    
    IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE, 
    INCIDENTAL OR CONSEQUENTIAL LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND 
    WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF MICROCHIP 
    HAS BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO 
    THE FULLEST EXTENT ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL 
    CLAIMS IN ANY WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT 
    OF FEES, IF ANY, THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS 
    SOFTWARE.
*/

#include "mcc_generated_files/mcc.h"

/********************** I2C functions **************************/

void I2C_Init(uint32_t i2c_clk_freq)
{
	SSP1STAT = 0x00;
	SSP1CON1 = 0x28;
	SSP1CON2 = 0x00;
	SSP1ADD = (_XTAL_FREQ / (4 * i2c_clk_freq)) - 1;  // set I2C clock frequency
}

void I2C_Start(void)
{
	mssp_clearIRQ();
	i2c_driver_start();
	mssp_waitForEvent(500);
}

void I2C_Stop(void)
{
	mssp_clearIRQ();
	i2c_driver_stop();
	mssp_waitForEvent(500);
}

void I2C_Write(uint8_t i2c_data)
{
	mssp_clearIRQ();
	SSP1BUF = i2c_data;
	mssp_waitForEvent(500);
}

#if 0
uint8_t I2C_Read(uint8_t ack)
{
	uint8_t _data;
	mssp_clearIRQ();
    i2c_driver_startRX();
    mssp_waitForEvent(500);
	mssp_clearIRQ();
	_data = i2c_driver_getRXData();
    mssp_waitForEvent(500);
    mssp_clearIRQ();
	if (ack == 1)
		i2c_driver_sendACK();
	else
		i2c_driver_sendNACK();
	mssp_waitForEvent(500);
	return _data;  // return data read
}
#else
uint8_t I2C_Read(uint8_t ack)
{
	uint8_t _data;
	while ((SSPSTAT & 0x04) || (SSPCON2 & 0x1F));  // wait for MSSP module to be free (not busy)
	RCEN = 1;
	while ((SSPSTAT & 0x04) || (SSPCON2 & 0x1F));  // wait for MSSP module to be free (not busy)
	_data = SSPBUF;  // read data from buffer
	while ((SSPSTAT & 0x04) || (SSPCON2 & 0x1F));  // wait for MSSP module to be free (not busy)
	// send acknowledge pulse ? (depends on ack, if 1 send, otherwise don't send)
	ACKDT = !ack;
	ACKEN = 1;
	return _data;  // return data read
}
#endif

void write_to_i2c(uint8_t i2c_address, uint8_t command, uint8_t chr)
{ 
	I2C_Start();
	I2C_Write(i2c_address);
	I2C_Write(command);
	I2C_Write(chr);
	I2C_Stop();
}

/********************** end I2C functions **********************/

/* -------------------- store font to eeprom ------------------*/
__EEPROM_DATA(0x00, 0x00, 0x60, 0x60, 0x00, 0x00, 0x00, 0x20);
__EEPROM_DATA(0x10, 0x08, 0x04, 0x02, 0x00, 0x3e, 0x51, 0x49);
__EEPROM_DATA(0x45, 0x3e, 0x00, 0x00, 0x42, 0x7f, 0x40, 0x00);
__EEPROM_DATA(0x00, 0x42, 0x61, 0x51, 0x49, 0x46, 0x00, 0x21);
__EEPROM_DATA(0x41, 0x45, 0x4b, 0x31, 0x00, 0x18, 0x14, 0x12);
__EEPROM_DATA(0x7f, 0x10, 0x00, 0x27, 0x45, 0x45, 0x45, 0x39);
__EEPROM_DATA(0x00, 0x3c, 0x4a, 0x49, 0x49, 0x30, 0x00, 0x01);
__EEPROM_DATA(0x71, 0x09, 0x05, 0x03, 0x00, 0x36, 0x49, 0x49);
__EEPROM_DATA(0x49, 0x36, 0x00, 0x06, 0x49, 0x49, 0x29, 0x1e);
__EEPROM_DATA(0x00, 0x00, 0x36, 0x36, 0x00, 0x00, 0x00, 0x00);
__EEPROM_DATA(0x56, 0x36, 0x00, 0x00, 0x00, 0x08, 0x14, 0x22);
__EEPROM_DATA(0x41, 0x00, 0x00, 0x14, 0x14, 0x14, 0x14, 0x14);
__EEPROM_DATA(0x00, 0x00, 0x41, 0x22, 0x14, 0x08, 0x00, 0x02);
__EEPROM_DATA(0x01, 0x51, 0x09, 0x06, 0x00, 0x32, 0x49, 0x59);
__EEPROM_DATA(0x51, 0x3e, 0x00, 0x7c, 0x12, 0x11, 0x12, 0x7c);
__EEPROM_DATA(0x00, 0x7f, 0x49, 0x49, 0x49, 0x36, 0x00, 0x3e);
__EEPROM_DATA(0x41, 0x41, 0x41, 0x22, 0x00, 0x7f, 0x41, 0x41);
__EEPROM_DATA(0x22, 0x1c, 0x00, 0x7f, 0x49, 0x49, 0x49, 0x41);
__EEPROM_DATA(0x00, 0x7f, 0x09, 0x09, 0x09, 0x01, 0x00, 0x3e);
__EEPROM_DATA(0x41, 0x49, 0x49, 0x7a, 0x00, 0x7f, 0x08, 0x08);
__EEPROM_DATA(0x08, 0x7f, 0x00, 0x00, 0x41, 0x7f, 0x41, 0x00);
__EEPROM_DATA(0x00, 0x20, 0x40, 0x41, 0x3f, 0x01, 0x00, 0x7f);
__EEPROM_DATA(0x08, 0x14, 0x22, 0x41, 0x00, 0x7f, 0x40, 0x40);
__EEPROM_DATA(0x40, 0x40, 0x00, 0x7f, 0x02, 0x0c, 0x02, 0x7f);
__EEPROM_DATA(0x00, 0x7f, 0x04, 0x08, 0x10, 0x7f, 0x00, 0x3e);
__EEPROM_DATA(0x41, 0x41, 0x41, 0x3e, 0x00, 0x7f, 0x09, 0x09);
__EEPROM_DATA(0x09, 0x06, 0x00, 0x3e, 0x41, 0x51, 0x21, 0x5e);
__EEPROM_DATA(0x00, 0x7f, 0x09, 0x19, 0x29, 0x46, 0x00, 0x46);
__EEPROM_DATA(0x49, 0x49, 0x49, 0x31, 0x00, 0x01, 0x01, 0x7f);
__EEPROM_DATA(0x01, 0x01, 0x00, 0x3f, 0x40, 0x40, 0x40, 0x3f);
__EEPROM_DATA(0x00, 0x1f, 0x20, 0x40, 0x20, 0x1f, 0x00, 0x3f);
__EEPROM_DATA(0x40, 0x38, 0x40, 0x3f, 0xff, 0x01, 0x0D, 0x1B);

/*
uint8_t display power on or off at startup at eeprom address eeprom[253]
uint16_t ina226 calibration is stored to the eeprom[254] and eeprom[255], defaul hex value is 0x0D1B (dec value 3355) */
/*
(0x00, 0x00, 0x60, 0x60, 0x00, 0x00);	// .      46
(0x00, 0x20, 0x10, 0x08, 0x04, 0x02);	// /
(0x00, 0x3E, 0x51, 0x49, 0x45, 0x3E);	// 0
(0x00, 0x00, 0x42, 0x7F, 0x40, 0x00);	// 1
(0x00, 0x42, 0x61, 0x51, 0x49, 0x46);	// 2
(0x00, 0x21, 0x41, 0x45, 0x4B, 0x31);	// 3
(0x00, 0x18, 0x14, 0x12, 0x7F, 0x10);	// 4
(0x00, 0x27, 0x45, 0x45, 0x45, 0x39);	// 5
(0x00, 0x3C, 0x4A, 0x49, 0x49, 0x30);	// 6
(0x00, 0x01, 0x71, 0x09, 0x05, 0x03);	// 7
(0x00, 0x36, 0x49, 0x49, 0x49, 0x36);	// 8
(0x00, 0x06, 0x49, 0x49, 0x29, 0x1E);	// 9
(0x00, 0x00, 0x36, 0x36, 0x00, 0x00);	// :
(0x00, 0x00, 0x56, 0x36, 0x00, 0x00);	// ;
(0x00, 0x08, 0x14, 0x22, 0x41, 0x00);	// <
(0x00, 0x14, 0x14, 0x14, 0x14, 0x14);	// =
(0x00, 0x00, 0x41, 0x22, 0x14, 0x08);	// >
(0x00, 0x02, 0x01, 0x51, 0x09, 0x06);	// ?
(0x00, 0x32, 0x49, 0x59, 0x51, 0x3E);	// @
(0x00, 0x7C, 0x12, 0x11, 0x12, 0x7C);	// A
(0x00, 0x7F, 0x49, 0x49, 0x49, 0x36);	// B
(0x00, 0x3E, 0x41, 0x41, 0x41, 0x22);	// C
(0x00, 0x7F, 0x41, 0x41, 0x22, 0x1C);	// D
(0x00, 0x7F, 0x49, 0x49, 0x49, 0x41);	// E
(0x00, 0x7F, 0x09, 0x09, 0x09, 0x01);	// F
(0x00, 0x3E, 0x41, 0x49, 0x49, 0x7A);	// G
(0x00, 0x7F, 0x08, 0x08, 0x08, 0x7F);	// H
(0x00, 0x00, 0x41, 0x7F, 0x41, 0x00);	// I
(0x00, 0x20, 0x40, 0x41, 0x3F, 0x01);	// J
(0x00, 0x7F, 0x08, 0x14, 0x22, 0x41);	// K
(0x00, 0x7F, 0x40, 0x40, 0x40, 0x40);	// L
(0x00, 0x7F, 0x02, 0x0C, 0x02, 0x7F);	// M
(0x00, 0x7F, 0x04, 0x08, 0x10, 0x7F);	// N
(0x00, 0x3E, 0x41, 0x41, 0x41, 0x3E);	// O
(0x00, 0x7F, 0x09, 0x09, 0x09, 0x06);	// P
(0x00, 0x3E, 0x41, 0x51, 0x21, 0x5E);	// Q
(0x00, 0x7F, 0x09, 0x19, 0x29, 0x46);	// R
(0x00, 0x46, 0x49, 0x49, 0x49, 0x31);	// S
(0x00, 0x01, 0x01, 0x7F, 0x01, 0x01);	// T
(0x00, 0x3F, 0x40, 0x40, 0x40, 0x3F);	// U
(0x00, 0x1F, 0x20, 0x40, 0x20, 0x1F);	// V
(0x00, 0x3F, 0x40, 0x38, 0x40, 0x3F);	// W      87
*/

/*------------------------------ SSD1306 128x32 definitions ---------------------------------*/

#define SSD1306_128x32	1
//#define SSD1306_128x64	1

#define SSD1306_I2C_ADDRESS	         (0x3C << 1)

#define SSD1306_LCDWIDTH             128
#if SSD1306_128x64
#define SSD1306_LCDHEIGHT            64
#endif

#if SSD1306_128x32
#define SSD1306_LCDHEIGHT            32
#endif

#if SSD1306_128x64
#define y_max	8
#endif

#if SSD1306_128x32
#define y_max	4
#endif

#define CMD	0x00
#define DAT	0x40

#define CHAR_SPACE 2	// space in pixels between characters

#define SSD1306_NORMALDISPLAY        0xA6
#define SSD1306_INVERTDISPLAY_       0xA7
#define SSD1306_DISPLAYOFF           0xAE
#define SSD1306_DISPLAYON            0xAF
#define SSD1306_SETDISPLAYOFFSET     0xD3
#define SSD1306_SETCOMPINS           0xDA
#define SSD1306_SETVCOMDETECT        0xDB
#define SSD1306_SETDISPLAYCLOCKDIV   0xD5
#define SSD1306_SETPRECHARGE         0xD9
#define SSD1306_SETCONTRAST          0x81
#define SSD1306_DISPLAYALLON_RESUME  0xA4
#define SSD1306_SETMULTIPLEX         0xA8
#define SSD1306_SETLOWCOLUMN         0x00
#define SSD1306_SETHIGHCOLUMN        0x10
#define SSD1306_SETSTARTLINE         0x40
#define SSD1306_MEMORYMODE           0x20
#define SSD1306_COLUMNADDR           0x21
#define SSD1306_PAGEADDR             0x22
#define SSD1306_COMSCANINC           0xC0
#define SSD1306_COMSCANDEC           0xC8
#define SSD1306_SEGREMAP             0xA0
#define SSD1306_CHARGEPUMP           0x8D
#define SSD1306_EXTERNALVCC          0x01
#define SSD1306_SWITCHCAPVCC         0x02
#define Set_Page_Start_Address_CMD   0xB0

#if SSD1306_128x32
// Init sequence for Adafruit 128x32 OLED module
uint8_t ssd1306_init_sequence[25] = {
	SSD1306_DISPLAYOFF,               // 0xAE
	SSD1306_SETDISPLAYCLOCKDIV,       // 0xD5
	0x80,                             // the suggested ratio 0x80
	SSD1306_SETMULTIPLEX,             // 0xA0
	0x1F,                             // ratio 32
	SSD1306_SETDISPLAYOFFSET,         // 0xD3
	0x00,                             // no offset
	SSD1306_SETSTARTLINE | 0x00,      // line #0
	SSD1306_CHARGEPUMP,               // 0x8D
	0x14,                             // internal vcc
	SSD1306_MEMORYMODE,               // 0x20
	0x02,                             // page mode
	SSD1306_SEGREMAP | 0x1,           // column 127 mapped to SEG0
	SSD1306_COMSCANDEC,               // column scan direction reversed
	SSD1306_SETCOMPINS,               // 0xDA
	0x02,                             // sequential COM pins, disable remap
	SSD1306_SETCONTRAST,              // 0x81
	25,	//0x7F,                             // contrast level 127
	SSD1306_SETPRECHARGE,             // 0xD9
	0xF1,                             // pre-charge period (1, 15)
	SSD1306_SETVCOMDETECT,            // 0xDB
	0x40,                             // vcomh regulator level
	SSD1306_DISPLAYALLON_RESUME,      // 0xA4
	SSD1306_NORMALDISPLAY,            // 0xA6
	SSD1306_DISPLAYON                 // 0xAF
};
#endif

#if SSD1306_128x64
// Init sequence for Adafruit 128x64 OLED module
uint8_t ssd1306_init_sequence[25] = {
	SSD1306_DISPLAYOFF,
	SSD1306_SETDISPLAYCLOCKDIV,
	0x80,                             // the suggested ratio 0x80
	SSD1306_SETMULTIPLEX,
	0x3F,                             // ratio 64
	SSD1306_SETDISPLAYOFFSET,
	0x0,                              // no offset
	SSD1306_SETSTARTLINE | 0x0,       // line #0
	SSD1306_CHARGEPUMP,
	0x14,                             // internal vcc
	SSD1306_MEMORYMODE,
	0x02,                             // page mode
	SSD1306_SEGREMAP | 0x1,           // column 127 mapped to SEG0
	SSD1306_COMSCANDEC,               // column scan direction reversed
	SSD1306_SETCOMPINS,
	0x12,                             // alt COM pins, disable remap
	SSD1306_SETCONTRAST,
	0x7F,                             // contrast level 127
	SSD1306_SETPRECHARGE,
	0xF1,                             // pre-charge period (1, 15)
	SSD1306_SETVCOMDETECT,
	0x40,                             // vcomh regulator level
	SSD1306_DISPLAYALLON_RESUME,
	SSD1306_NORMALDISPLAY,
	SSD1306_DISPLAYON
};
#endif

uint8_t display_status;
uint8_t setup = 0;

void ssd1306_init(void)
{
	uint8_t i;
	
	for (i=0; i < 25; ++i)
		write_to_i2c(SSD1306_I2C_ADDRESS, CMD, ssd1306_init_sequence[i]);
}

void ssd1306_print_string(uint8_t x_pos, uint8_t y_pos, char *ch)
{
	uint8_t i = 0;
    uint8_t j = 0;

	if (display_status || setup)
	{
		while(ch[i])
		{
			x_pos += CHAR_SPACE;
	
			if (x_pos > (SSD1306_LCDWIDTH - 6))
			{
				x_pos = 0;
				y_pos += 1;
			}
	
			write_to_i2c(SSD1306_I2C_ADDRESS, CMD, Set_Page_Start_Address_CMD + y_pos);        // set row
			write_to_i2c(SSD1306_I2C_ADDRESS, CMD, SSD1306_SETLOWCOLUMN | (x_pos & 0xf));      // set lower column address
			write_to_i2c(SSD1306_I2C_ADDRESS, CMD, SSD1306_SETHIGHCOLUMN | (x_pos >> 4));      // set higher column address
	
			if ((ch[i] < 46) || (ch[i] > 87))
			{
					for (j=0; j < 6; ++j)
						write_to_i2c(SSD1306_I2C_ADDRESS, DAT, 0x00);
			}
			else
			{
					for (j=0; j < 6; ++j)
						write_to_i2c(SSD1306_I2C_ADDRESS, DAT, eeprom_read(((ch[i] - 46) * 6) + j));
			}
	
			i += 1;
			x_pos += 6;
		}
	}
}

void ssd1306_fill(uint8_t bmp_data) 
{                                                     
	uint8_t x_pos = 0;
	uint8_t page = 0;

    if (display_status || setup)
	{
		for (page=0; page < y_max; ++page)
		{
			write_to_i2c(SSD1306_I2C_ADDRESS, CMD, (Set_Page_Start_Address_CMD + page));
			write_to_i2c(SSD1306_I2C_ADDRESS, CMD, SSD1306_SETLOWCOLUMN);
			write_to_i2c(SSD1306_I2C_ADDRESS, CMD, SSD1306_SETHIGHCOLUMN);
	
			for (x_pos=0; x_pos < SSD1306_LCDWIDTH; ++x_pos)
				write_to_i2c(SSD1306_I2C_ADDRESS, DAT, bmp_data);                                                                                  
		}
	}
}

void ssd1306_reset_display(void)
{
	IO_RA0_SetDigitalOutput();
	__delay_us(100);
	IO_RA0_SetLow();
	__delay_us(100);
	IO_RA0_SetHigh();
	__delay_ms(10);
	ssd1306_fill(0x00);
}

#if 0
void get_dec_str(char *str, uint8_t len, int32_t val)	// replace sprintf
{
	uint8_t i;

	for(i=1; i <= len; ++i)
	{
		str[len-i] = (uint8_t)((val % 10) + '0');
		val /= 10;
	}

	str[i-1] = '\0';
}
#endif

#define MCP4725_V_I2C_ADDRESS	0x60
#define MCP4725_A_I2C_ADDRESS	0x61

#define MCP4726_CMD_WRITEDAC            0x40  // Writes data to the DAC
#define MCP4726_CMD_WRITEDACEEPROM      0x60  // Writes data to the DAC and the EEPROM (persisting the assigned value after reset)

//#define DAC_SUPPLY_MVOLT	4980
//#define FB_MVOLT		1243
//#define RESISTOR_R1		330
//#define RESISTOR_R2		6200
//#define RESISTOR_RB		1000

/*
feedback mili volt = 1243			
R1=330 
R2=6200 
Rb=1000 
DAC Max Output = Vdd = 4.980V 
  
For DAC input code = 3299 (4011 mV) 
  
IR1 = 1243 / 330 = 3.7666 mA 
IRb = (4011 - 1243) / 1000 =  2.768 mA 
IR2 = 3.7666 - 2.768 = 0.9986 mA 
VR2 = 0.9986 * 6200 = 6191 mV 
Regulated Output = 6191 + 1243 = 7434 mV

        float mili_voltage = (((FB_MVOLT / RESISTOR_R1) - (((val * (DAC_SUPPLY_MVOLT / 4096)) - FB_MVOLT) / 1000)) * RESISTOR_R2) + FB_MVOLT
        float mili_voltage = (((1243 / 330) - (((3299 * (4980 / 4096)) - 1243) / 1000)) * 6200) + 1243
        mili_voltage = 7434;								                
*/

uint16_t MCP4725_read(uint8_t address)
{
	uint8_t buffer[3];
	uint16_t value;
	
	I2C_Start();
	I2C_Write((address << 1) + 1);
	buffer[0] = I2C_Read(1);
	buffer[1] = I2C_Read(1);
	buffer[2] = I2C_Read(0);
	I2C_Stop();
	value = buffer[1];
	value = value << 4;
	value = value + (buffer[2] >> 4);
	return value;
}

void MCP4725_write(uint8_t address, uint16_t val, uint8_t writeEEPROM)
{
	uint8_t buffer[4];

	buffer[0] = (address << 1);

	if (writeEEPROM)                                // command and config bits  (C2.C1.C0.x.x.PD1.PD0.x)
		buffer[1] = MCP4726_CMD_WRITEDACEEPROM;
	else
		buffer[1] = MCP4726_CMD_WRITEDAC;

	buffer[2] = (val / 16);                         // Upper data bits          (D11.D10.D9.D8.D7.D6.D5.D4)
	buffer[3] = (val % 16) << 4;                    // Lower data bits          (D3.D2.D1.D0.x.x.x.x)

	I2C_Start();
	I2C_Write(buffer[0]);
	I2C_Write(buffer[1]);
	I2C_Write(buffer[2]);
	I2C_Write(buffer[3]);
	I2C_Stop();
}

/*
int16_t Adafruit_ADS1015::readADC_SingleEnded(uint8_t channel) {
  if (channel > 3)
  {
    return 0;
  }
  
  // Start with default values
  uint16_t config = ADS1X15_REG_CONFIG_CQUE_NONE    | // Disable the comparator (default val) (0x0003)
                    ADS1X15_REG_CONFIG_CLAT_NONLAT  | // Non-latching (default val)           (0x0000)
                    ADS1X15_REG_CONFIG_CPOL_ACTVLOW | // Alert/Rdy active low   (default val) (0x0000)
                    ADS1X15_REG_CONFIG_CMODE_TRAD   | // Traditional comparator (default val) (0x0000)
                    ADS1X15_REG_CONFIG_MODE_SINGLE;   // Single-shot mode (default)           (0x0100)

  // Set PGA/voltage range
  config |= m_gain; // gain 4_096 (0x0200)
  
  // Set Samples per Second
  config |= m_SPS; // 128 samples per seccond (0x0080)

  // Set single-ended input channel
    //#define ADS1X15_REG_CONFIG_MUX_SINGLE_0 (0x4000)  // Single-ended AIN0
    //#define ADS1X15_REG_CONFIG_MUX_SINGLE_1 (0x5000)  // Single-ended AIN1
    //#define ADS1X15_REG_CONFIG_MUX_SINGLE_2 (0x6000)  // Single-ended AIN2
    //#define ADS1X15_REG_CONFIG_MUX_SINGLE_3 (0x7000)  // Single-ended AIN3
  config |= getSingleEndedConfigBitsForMUX(channel); // channel 0 single ended (0x4000)

  // Set 'start single-conversion' bit
  config |= ADS1X15_REG_CONFIG_OS_SINGLE; // (0x8000)

  // 0xc383 je konfig register
  // Write config register to the ADC
  writeRegister(m_i2cAddress, ADS1X15_REG_POINTER_CONFIG, config);
  
  // Wait for the conversion to complete
  waitForConversion();

  return getLastConversionResults();                                      // conversion delay is included in this method
}
*/

#if 0
// https://github.com/soligen2010/Adafruit_ADS1X15/blob/master/Adafruit_ADS1015.cpp

#define ADS1115_I2C_ADDRESS	(0x48 << 1)
#define ADS1115_CHANNEL_0	0xC3
#define ADS1115_CHANNEL_1	0xD3

uint16_t ADS1115_Read(uint8_t channel)
{
	uint8_t timeout;
	uint8_t buffer[2];

	// set config register and start conversion
	// AIN0 and GND, 4.096v, 128sps
	I2C_Start();
	I2C_Write(ADS1115_I2C_ADDRESS);
	I2C_Write(1);
	I2C_Write(channel);	// channel 0 = 0xc3, channel 1 0xd3, channel 2 0xe3, channel 3 0xf3
	I2C_Write(0x83);
	I2C_Stop();

    // wait for conversion complete (10ms max)
	timeout = 100;
	do {
		I2C_Start();
		I2C_Write(ADS1115_I2C_ADDRESS+1);
		buffer[0] = I2C_Read(1);
		buffer[1] = I2C_Read(0);
		I2C_Stop();
		__delay_us(100);
	} while (!(buffer[0] & 0x80) && --timeout);

	// read conversion register
	I2C_Start();
	I2C_Write(ADS1115_I2C_ADDRESS);
	I2C_Write(0x00);	// conversion register is 0
	I2C_Stop();
	I2C_Start();
	I2C_Write(ADS1115_I2C_ADDRESS+1);
	buffer[0] = I2C_Read(1);
	buffer[1] = I2C_Read(0);
	I2C_Stop();

	return buffer[0] << 8 | buffer[1];
}
#endif

// https://github.com/dpeters1/Simple-INA226/blob/master/Simple-INA226.cpp
const float VOLTAGE_LSB = 0.00125;
const float POWER_LSB = 25.0;
const float _CURRENT_LSB = 0.00015258789;	// (maxAmps / 32768);
const uint8_t INA226_CONFIG_REG = 0;          // Register locations
const uint8_t INA226_SHUNT_VOLTAGE_REG = 1;
const uint8_t INA226_BUS_VOLTAGE_REG = 2;
const uint8_t INA226_POWER_REG = 3;
const uint8_t INA226_CURRENT_REG = 4;
const uint8_t INA226_CALIBRATION_REG = 5;
const uint8_t INA226_I2C_ADDR = 0x40;
const uint16_t INA226_CONFIGURATION = 0x4527; // Device configuration - 0x4427 corresponds to:
                                              // Bus and Shunt Voltage Conversion time: 1.1ms
                                              // Sample Averages: 16
                                              // Operating Mode: Shunt and Bus, Continuous

uint16_t calibration = 0;

void INA226_init(void)
{
	calibration = eeprom_read(254) << 8;	//3355;	//3.35544321374;	// 0.00512 / (_CURRENT_LSB * 10 mOHM);
	calibration |= eeprom_read(255);

	I2C_Start();
	I2C_Write(INA226_I2C_ADDR << 1);
	I2C_Write(INA226_CONFIG_REG);
    I2C_Write((INA226_CONFIGURATION >> 8) & 0xff);
    I2C_Write(INA226_CONFIGURATION & 0xff);
	I2C_Stop();

	I2C_Start();
	I2C_Write(INA226_I2C_ADDR << 1);
	I2C_Write(INA226_CALIBRATION_REG);
    I2C_Write((calibration >> 8) & 0xff);
    I2C_Write(calibration & 0xff);
	I2C_Stop();
} 

void write_buf(char *dest, float value, uint8_t dsp)
{
	dest[0] = (uint8_t)(((int32_t)(value/10000)%10) + '0');
	dest[1] = (uint8_t)(((int32_t)(value/1000)%10) + '0');
	dest[2] = '.';
	dest[3] = (uint8_t)(((int32_t)(value/100)%10) + '0');
	dest[4] = (uint8_t)(((int32_t)(value/10)%10) + '0');
	dest[5] = (uint8_t)(((int32_t)(value)%10) + '0');

    switch(dsp)
	{
        case 1:
			dest[6] = ' ';
			dest[7] = 'V';			
            break;
        
        case 2:
            dest[6] = ' ';
			dest[7] = 'A';
            break;

        case 3:
            dest[6] = ' ';
			dest[7] = 'W';
            break;

        default:
            break;
    }
}

char hexDigit(unsigned n)
{
    if (n < 10) {
        return n + '0';
    } else {
       return (n - 10) + 'A';
    }
}

void INA226_get(char *dest, uint8_t dest_sz, uint8_t mode, uint8_t column, uint8_t row, int8_t reset_buffer)
{
	uint8_t buffer[2];
	uint16_t res;
	uint8_t i;
	float volt, current, power;

	I2C_Start();
	I2C_Write(INA226_I2C_ADDR << 1);
	I2C_Write(mode);
	I2C_Stop();
	I2C_Start();
	I2C_Write((INA226_I2C_ADDR << 1) + 1);
	buffer[0] = I2C_Read(1);
	buffer[1] = I2C_Read(0);
	I2C_Stop();

	if (buffer[0] == 255)
		buffer[0] = 0;

	if (buffer[1] == 255)
		buffer[1] = 0;

	res = buffer[0] << 8 | buffer[1];

	if (reset_buffer)
	{
		for (i=0; i < dest_sz; ++i)
			dest[i] = '\0';
	}

	switch(mode)
	{
        //case INA226_SHUNT_VOLTAGE_REG:
        //    break;

		case INA226_BUS_VOLTAGE_REG:
			volt = res * VOLTAGE_LSB * 1000;
			write_buf(dest, volt, 1);						
			break;

		case INA226_CURRENT_REG:
			current = res * _CURRENT_LSB * 1000;
			write_buf(dest, current, 2);
			break;

		case INA226_POWER_REG:
			power = res * _CURRENT_LSB * POWER_LSB * 1000;
			write_buf(dest, power, 3);
			break;

		default:
			break;
	}

	ssd1306_print_string(column, row, dest);	
}

#define ENG
//#define SRB

#ifdef ENG
#define OLED_STRING "OLED DEFAULT"
#define OLED_ON_STRING "ON "
#define OLED_OFF_STRING "OFF"
#define CALIBRATION_STRING "CALIBRATION"
#define VOLTAGE_SETUP_STRING "VOLTAGE SETUP"
#define AMPERE_SETUP_STRING "AMPERE SETUP"
#define SAVE_FALSE_STRING "SAVE? FALSE"
#define SAVE_TRUE_STRING "SAVE? TRUE"
#define RESETTLED_STRING "RESETTLED."
#define SAVED_STRING "SAVED."
#endif

#ifdef SRB
#define OLED_STRING "OLED START"
#define OLED_ON_STRING "DA"
#define OLED_OFF_STRING "NE"
#define CALIBRATION_STRING "KALIBRACIJA"
#define VOLTAGE_SETUP_STRING "PODESI NAPON"
#define AMPERE_SETUP_STRING "PODESI STRUJU"
#define SAVE_FALSE_STRING "SACUVAJ? NE"
#define SAVE_TRUE_STRING "SACUVAJ? DA"
#define RESETTLED_STRING "RESETOVANO."
#define SAVED_STRING "SACUVANO."
#endif

void main(void)
{
	uint8_t i = 0;
	uint8_t fill = 1;
	uint16_t mili_volts = 0, mili_volts_bak = 0;
	uint16_t mili_amps = 0, mili_amps_bak = 0;
	char buf[14];
	uint8_t buf_sz = sizeof(buf);		

    // initialize the device
    SYSTEM_Initialize();

    // When using interrupts, you need to set the Global and Peripheral Interrupt Enable bits
    // Use the following macros to:

    // Enable the Global Interrupts
    INTERRUPT_GlobalInterruptEnable();

    // Enable the Peripheral Interrupts
    INTERRUPT_PeripheralInterruptEnable();

    // Disable the Global Interrupts
    //INTERRUPT_GlobalInterruptDisable();

    // Disable the Peripheral Interrupts
    //INTERRUPT_PeripheralInterruptDisable();

    I2C_Init(100000);               // initialize I2C bus with clock frequency of 100kHz

    // reset display
	ssd1306_reset_display();

	ssd1306_init();

	INA226_init();

	__delay_ms(50);

    display_status = eeprom_read(253);

	if (display_status == 0)
		write_to_i2c(SSD1306_I2C_ADDRESS, CMD, SSD1306_DISPLAYOFF);

    while (!setup)
    {
		if (IO_RA4_GetValue() == HIGH && IO_RA5_GetValue() == HIGH)
		{
			if (display_status == 1)
			{
				display_status = 0;
				write_to_i2c(SSD1306_I2C_ADDRESS, CMD, SSD1306_DISPLAYOFF);
			}
			else
			{
				display_status = 1;
				write_to_i2c(SSD1306_I2C_ADDRESS, CMD, SSD1306_DISPLAYON);
				fill = 1;
			}
		}

		if (fill)
		{
			ssd1306_fill(0x00);
			fill = 0;
		}

		mili_volts = MCP4725_read(MCP4725_V_I2C_ADDRESS);
        mili_amps  = MCP4725_read(MCP4725_A_I2C_ADDRESS);
        mili_volts_bak = mili_volts;
        mili_amps_bak = mili_amps;

        //INA226_get(buf, buf_sz, INA226_SHUNT_VOLTAGE_REG);
		INA226_get(buf, buf_sz, INA226_BUS_VOLTAGE_REG, 32, 0, 1);		
		INA226_get(buf, buf_sz, INA226_CURRENT_REG, 32, 1, 1);
		INA226_get(buf, buf_sz, INA226_POWER_REG, 32, 2, 1);

		if (IO_RA4_GetValue() == HIGH && IO_RA5_GetValue() == LOW)
		{
			if ((fill == 0) && (display_status == 1))
				setup += 1;
			fill = 1;
		}

		__delay_ms(200);
	}

	while (setup)
	{
		if (IO_RA4_GetValue() == HIGH && IO_RA5_GetValue() == LOW)
		{
			if (fill == 0)
				setup += 1;
			fill = 1;
			__delay_ms(100);
		}

		switch (setup)
		{
			case 1:
				if (fill)
				{
					ssd1306_fill(0x00);
					ssd1306_print_string(0, 0, OLED_STRING);

                    if (display_status == 1)
						ssd1306_print_string(0, 2, OLED_ON_STRING);
					else
						ssd1306_print_string(0, 2, OLED_OFF_STRING);											

					fill = 0;
				}

				while (IO_RA5_GetValue() == HIGH)
				{
					if (IO_RA4_GetValue() == HIGH)
					{
						display_status = 0;
						ssd1306_print_string(0, 2, OLED_OFF_STRING);
					}
					else
					{
						display_status = 1;
						ssd1306_print_string(0, 2, OLED_ON_STRING);
					}
					__delay_ms(400);
				}
				break;

			case 2:
				if (fill)
				{
					ssd1306_fill(0x00);
					ssd1306_print_string(0, 0, CALIBRATION_STRING);
					fill = 0;
				}

				while (IO_RA5_GetValue() == HIGH)
				{
					if (IO_RA4_GetValue() == HIGH)
					{
						if (calibration > 1)
							calibration -= 1;
					}
					else
					{
						if (calibration < 65535)
							calibration += 1;
					}

					buf[0] = hexDigit(((uint8_t)((calibration >> 8) & 0xff)) / 0x10);
					buf[1] = hexDigit(((uint8_t)((calibration >> 8) & 0xff)) % 0x10);
					buf[2] = hexDigit(((uint8_t)(calibration & 0xff)) / 0x10);
					buf[3] = hexDigit(((uint8_t)(calibration & 0xff)) % 0x10);
					buf[4] = '\0';					
					ssd1306_print_string(0, 2, buf);
					__delay_ms(200);
				}

				buf[0] = hexDigit(((uint8_t)((calibration >> 8) & 0xff)) / 0x10);
				buf[1] = hexDigit(((uint8_t)((calibration >> 8) & 0xff)) % 0x10);
				buf[2] = hexDigit(((uint8_t)(calibration & 0xff)) / 0x10);
				buf[3] = hexDigit(((uint8_t)(calibration & 0xff)) % 0x10);
				buf[4] = '\0';					
				ssd1306_print_string(0, 2, buf);
				break;

			case 3:
				if (fill)
				{
					ssd1306_fill(0x00);
					ssd1306_print_string(0, 0, VOLTAGE_SETUP_STRING);
					mili_amps = 30;
					MCP4725_write(MCP4725_A_I2C_ADDRESS, mili_amps, 0);	// reset ampere to smaller value in case max input voltage is set, to get power not bigger than 50 W
					fill = 0;
				}

				while (IO_RA5_GetValue() == HIGH)
				{
					mili_volts += 1;

					if (IO_RA4_GetValue() == HIGH)
						mili_volts += 49;

					if (mili_volts > 4095)
						mili_volts = 0;
					if (mili_volts == 0 || mili_volts == 4095)
						__delay_ms(1000);
						
					MCP4725_write(MCP4725_V_I2C_ADDRESS, mili_volts, 0);
					
					buf[8] = ' ';
                    buf[9] = (uint8_t)(((int32_t)(mili_volts/1000)%10) + '0');
                    buf[10] = (uint8_t)(((int32_t)(mili_volts/100)%10) + '0');
                    buf[11] = (uint8_t)(((int32_t)(mili_volts/10)%10) + '0');
                    buf[12] = (uint8_t)(((int32_t)(mili_volts)%10) + '0');
                    buf[13] = '\0';
					INA226_get(buf, buf_sz, INA226_BUS_VOLTAGE_REG, 0, 2, 0);
					__delay_ms(200);
				}

				INA226_get(buf, buf_sz, INA226_BUS_VOLTAGE_REG, 0, 2, 0);
				break;

			case 4:
				if (fill)
				{
					ssd1306_fill(0x00);
					ssd1306_print_string(0, 0, AMPERE_SETUP_STRING);
					fill = 0;
				}

				while (IO_RA5_GetValue() == HIGH)
				{
					mili_amps += 1;

					if (IO_RA4_GetValue() == HIGH)
						mili_amps += 49;

					if (mili_amps > 4095)
						mili_amps = 0;
					if (mili_amps == 0 || mili_amps == 4095)
						__delay_ms(1000);

					MCP4725_write(MCP4725_A_I2C_ADDRESS, mili_amps, 0);

					buf[8] = ' ';
                    buf[9] = (uint8_t)(((int32_t)(mili_amps/1000)%10) + '0');
                    buf[10] = (uint8_t)(((int32_t)(mili_amps/100)%10) + '0');
                    buf[11] = (uint8_t)(((int32_t)(mili_amps/10)%10) + '0');
                    buf[12] = (uint8_t)(((int32_t)(mili_amps)%10) + '0');
                    buf[13] = '\0';
					INA226_get(buf, buf_sz, INA226_CURRENT_REG, 0, 2, 0);
					__delay_ms(200);
				}

				INA226_get(buf, buf_sz, INA226_CURRENT_REG, 0, 2, 0);
				break;

			case 5:
				if (fill)
				{
					ssd1306_fill(0x00);
					ssd1306_print_string(0, 0, SAVE_FALSE_STRING);
					fill = 0;
				}

				if (IO_RA5_GetValue() == HIGH)
				{
					MCP4725_write(MCP4725_V_I2C_ADDRESS, mili_volts_bak, 0);
					MCP4725_write(MCP4725_A_I2C_ADDRESS, mili_amps_bak, 0);
					ssd1306_print_string(0, 2, RESETTLED_STRING);
					__delay_ms(2000);
					setup = 0;
				}
				break;

			case 6:
				if (fill)
				{
					ssd1306_fill(0x00);
					ssd1306_print_string(0, 0, SAVE_TRUE_STRING);
					fill = 0;
				}

				if (IO_RA5_GetValue() == HIGH)
				{									
					MCP4725_write(MCP4725_V_I2C_ADDRESS, mili_volts, 1);
					MCP4725_write(MCP4725_A_I2C_ADDRESS, mili_amps, 1);

					buf[0] = (uint8_t)((calibration >> 8) & 0xff);
					buf[1] = (uint8_t)(calibration & 0xff);
					if (((uint16_t)(eeprom_read(254) << 8 | eeprom_read(255))) != calibration)
					{
						eeprom_write(254, buf[0]);
						eeprom_write(255, buf[1]);
						INA226_init();
					}
																	
					ssd1306_print_string(0, 2, SAVED_STRING);
					__delay_ms(2000);

					if ((uint8_t)eeprom_read(253) != display_status)
					{
						eeprom_write(253, display_status);
						if (display_status == 1)
							write_to_i2c(SSD1306_I2C_ADDRESS, CMD, SSD1306_DISPLAYON);
						else
							write_to_i2c(SSD1306_I2C_ADDRESS, CMD, SSD1306_DISPLAYOFF);
					}

					setup = 0;
				}
				break;

			case 7:
				MCP4725_write(MCP4725_V_I2C_ADDRESS, mili_volts_bak, 0);
				MCP4725_write(MCP4725_A_I2C_ADDRESS, mili_amps_bak, 0);
				ssd1306_print_string(0, 2, RESETTLED_STRING);
				__delay_ms(2000);
				fill = 1;
				setup = 0;
				break;

			default:
				break;
		}
    }
}
